#!/usr/bin/php
<?php
$db = '/tmp/ps-gh.db';

$home_dir = substr($_SERVER['SCRIPT_FILENAME'], 0, strrpos($_SERVER['SCRIPT_FILENAME'], '/'));
chdir($home_dir);

function get_partitions() {
	exec("grep storage_pool_directory /etc/greyhole.conf | awk -F'=' '{print $2}' | awk -F',' '{print $1}'", $gh_parts);
	return array_map('trim', $gh_parts);
}

function quoted_form($path) {
	return "'". str_replace("'", "'\\''", $path) ."'";
}

if (file_exists($db)) {
	echo date('[Y-m-d H:i:s]') ." rm ". quoted_form($db) ."\n";
	unlink($db);
}

# Index all storage pool directories
$partitions = get_partitions();
foreach ($partitions as $partition) {
	$cmd = "$home_dir/philesight --db ". quoted_form($db) ." --index ". quoted_form($partition) ." --one-file-system --virtual-root";
	echo date('[Y-m-d H:i:s]') ." exec $cmd\n";
	exec($cmd);
}

echo date('[Y-m-d H:i:s]') ." Done indexing.\n";
?>
