#!/usr/bin/php
<?php
$db = '/tmp/ps.db';

$home_dir = substr($_SERVER['SCRIPT_FILENAME'], 0, strrpos($_SERVER['SCRIPT_FILENAME'], '/'));
chdir($home_dir);

function get_partitions() {
	$partitions = array();
	$mtab = file_get_contents('/etc/mtab');
	foreach (explode("\n", $mtab) as $mount) {
		if (strpos($mount, '/dev') === FALSE) { continue; }
		$mount = explode(' ', $mount);
		$device = $mount[0];
		$path = $mount[1];
		if ($path == "/dev/pts") { continue; }
		if ($path == "/dev/shm") { continue; }
		if ($path == "/boot") { continue; }
		if ($path == "/tmp") { continue; }
		$partitions[] = $path;
	}
	return $partitions;
}

function quoted_form($path) {
	return "'". str_replace("'", "'\\''", $path) ."'";
}

if (file_exists($db)) {
	echo date('[Y-m-d H:i:s]') ." rm ". quoted_form($db) ."\n";
	unlink($db);
}

# Index / first
echo date('[Y-m-d H:i:s]') ." exec $home_dir/philesight --db ". quoted_form($db) ." --index / --one-file-system\n";
exec("$home_dir/philesight --db ". quoted_form($db) ." --index / --one-file-system");

# Index all mounts
$partitions = get_partitions();
foreach ($partitions as $partition) {
	if ($partition == '/') { continue; }
	echo date('[Y-m-d H:i:s]') ." exec $home_dir/philesight --db ". quoted_form($db) ." --index ". quoted_form($partition) ." --one-file-system\n";
	exec("$home_dir/philesight --db ". quoted_form($db) ." --index ". quoted_form($partition) ." --one-file-system");
}

# Re-index / last
echo date('[Y-m-d H:i:s]') ." exec $home_dir/philesight --db ". quoted_form($db) ." --index / --one-file-system\n";
exec("$home_dir/philesight --db ". quoted_form($db) ." --index / --one-file-system");

# Make sure all partitions are included in the graph
foreach ($partitions as $partition) {
	if ($partition == '/') { continue; }
	echo date('[Y-m-d H:i:s]') ." exec $home_dir/philesight_merge_root --db ". quoted_form($db) ." --path ". quoted_form($partition) ."\n";
	exec("$home_dir/philesight_merge_root --db ". quoted_form($db) ." --path ". quoted_form($partition));
}

echo date('[Y-m-d H:i:s]') ." Done indexing.\n";
?>
